import { Component, OnInit } from '@angular/core';
import { ToastrService } from 'ngx-toastr';
import { AlertService } from 'src/app/services/alert.service';
import { Adv2service} from './Adv2.service';
import { AbstractControl, FormArray, FormBuilder, FormGroup, Validators, ValidationErrors } from '@angular/forms';
import { ExtensionService } from 'src/app/services/fnd/extension.service';
import { DashboardContentModel2 } from 'src/app/models/builder/dashboard'; 
import { Adv2cardvariable } from './Adv2_cardvariable';
import { UserInfoService } from 'src/app/services/user-info.service';
declare var JsBarcode: any; 
@Component({
  selector: 'app-Adv2',
  templateUrl: './Adv2.component.html',
  styleUrls: ['./Adv2.component.scss']
})
export class Adv2Component implements OnInit {
  cardButton = Adv2cardvariable.cardButton;
  cardmodeldata = Adv2cardvariable.cardmodeldata;
  public dashboardArray: DashboardContentModel2[];
  isCardview = Adv2cardvariable.cardButton;
  cardmodal;  changeView(){
  this.isCardview = !this.isCardview;
  }
    beforeText(fieldtext: string): string { // Extract the text before the first '<'
    const index = fieldtext.indexOf('<');
    return index !== -1 ? fieldtext.substring(0, index) : fieldtext;
  }
  afterText(fieldtext: string): string { // Extract the text after the last '>'
    const index = fieldtext.lastIndexOf('>');
    return index !== -1 ? fieldtext.substring(index + 1) : '';
  }
  transform(fieldtext: string): string {
    const match = fieldtext.match(/<([^>]*)>/);
    return match ? match[1] : ''; // Extract the text between '<' and '>'
  }
 userrole;
  rowSelected :any= {};
  modaldelete=false;
  modalEdit=false;
  modalAdd= false;
  public entryForm: FormGroup;
  loading = false;
  product;
  modalOpenedforNewLine = false;
  newLine:any;
 additionalFieldsFromBackend: any[] = [];
  formcode = 'Adv2_formCode'
tableName = 'Adv2';  checkFormCode; selected: any[] = []; constructor(
    private extensionService: ExtensionService,
private userInfoService:UserInfoService,
    private mainService:Adv2service,
    private alertService: AlertService,
    private toastr: ToastrService,
    private _fb: FormBuilder,
  ) { }
// component button 
  ngOnInit(): void {
    if(this.cardmodeldata !== ''){
     this.cardmodal = JSON.parse(this.cardmodeldata);
    this.dashboardArray = this.cardmodal.dashboard.slice();
    console.log(this.dashboardArray)
    }
    this.userrole=this.userInfoService.getRoles();
    this.getData();
    this.entryForm = this._fb.group({
name : [null],

sta_mul : [null],

dynamic : [null],

dyanmic_mul : [null],

autocom : [null],

auto_mul : [null],


 











  }); // component_button200
 // form code start
    this.extensionService.getJsonObjectsByFormCodeList(this.formcode).subscribe(data => {
      console.log(data);
      const jsonArray = data.map((str) => JSON.parse(str));
      this.additionalFieldsFromBackend = jsonArray;
      this.checkFormCode = this.additionalFieldsFromBackend.some(field => field.formCode === "Adv2_formCode");
      console.log(this.checkFormCode);
      console.log(this.additionalFieldsFromBackend);
      if (this.additionalFieldsFromBackend && this.additionalFieldsFromBackend.length > 0) {
        this.additionalFieldsFromBackend.forEach(field => {
          if (field.formCode === this.formcode) {
            if (!this.entryForm.contains(field.extValue)) {
              // Add the control only if it doesn't exist in the form
              this.entryForm.addControl(field.extValue, this._fb.control(field.fieldValue));
            }
          }
        });
      }
    });
    console.log(this.entryForm.value);
    // form code end 




this.getalldynamic();

this.getalldyanmic_mul();

this.getallautocom();

this.getallauto_mul();


  }












 error; 
  getData() {
    this.mainService.getAll().subscribe((data) => {
      console.log(data);
      this.product = data;
 if(this.product.length==0){
        this.error="No Data Available"
     }   
    },(error) => {
      console.log(error);
      if(error){
       this.error="Server Error";
     }
    });
  }
  onEdit(row) {
    this.rowSelected = row;


this.nodeEditPropertiessta_mul.editselectedAttributessta_mul = JSON.parse(this.rowSelected.sta_mul );



this.nodeEditPropertiesdyanmic_mul.editselectedAttributesdyanmic_mul = JSON.parse(this.rowSelected.dyanmic_mul );



this.nodeEditPropertiesauto_mul.editselectedAttributesauto_mul = JSON.parse(this.rowSelected.auto_mul );


    this.modalEdit = true;
  }
   onDelete(row) {
    this.rowSelected = row;
     this.modaldelete=true;
  }
  delete(id)
  {
    this.modaldelete = false;
    console.log("in delete  "+id);
    this.mainService.delete(id).subscribe(
      (data) => {
        console.log(data);
        this.ngOnInit();
  if (data) {				      this.toastr.success('Deleted successfully');      }
    });
  }
    onUpdate(id) {
    this.modalEdit = false;


this.rowSelected.sta_mul  = JSON.stringify(this.nodeEditPropertiessta_mul.editselectedAttributessta_mul  );



this.rowSelected.dyanmic_mul  = JSON.stringify(this.nodeEditPropertiesdyanmic_mul.editselectedAttributesdyanmic_mul  );



this.rowSelected.auto_mul  = JSON.stringify(this.nodeEditPropertiesauto_mul.editselectedAttributesauto_mul  );

    //console.log("in update");
    console.log("id  " + id);
    console.log(this.rowSelected);
    //console.log("out update");
    this.mainService.update(id, this.rowSelected).subscribe(
      (data) => {
        console.log(data);
        if (data || data.status >= 200 && data.status <= 299) {
          this.toastr.success("Update Successfully");
        }
setTimeout(() => {
      this.ngOnInit();
    }, 500);












      }, (error) => {
        console.log(error);
        if (error.status >= 200 && error.status <= 299) {
          // this.toastr.success("update Succesfully");
        }
        if (error.status >= 400 && error.status <= 499) {
          this.toastr.error("Not Updated");
        }
        if (error.status >= 500 && error.status <= 599) {
          this.toastr.error("Not Updated");
        }
      });
    setTimeout(() => {
      this.ngOnInit();
    }, 500);
  } 
onCreate() {
     this.modalAdd=false;


this.entryForm.value.sta_mul  = JSON.stringify(this.nodeEditPropertiessta_mul.addselectedAttributessta_mul );



this.entryForm.value.dyanmic_mul  = JSON.stringify(this.nodeEditPropertiesdyanmic_mul.addselectedAttributesdyanmic_mul );



this.entryForm.value.auto_mul  = JSON.stringify(this.nodeEditPropertiesauto_mul.addselectedAttributesauto_mul );

  this.mainService.create(this.entryForm.value).subscribe(
    (data) => {
      console.log(data);
  if (data || data.status >= 200 && data.status <= 299) {
          this.toastr.success("Added Successfully");
        }
setTimeout(() => {
      this.ngOnInit();
    }, 500);












      }, (error) => {
        console.log(error);
        if (error.status >= 200 && error.status <= 299) {
          // this.toastr.success("Added Succesfully");
        }
        if (error.status >= 400 && error.status <= 499) {
          this.toastr.error("Not Added");
        }
        if (error.status >= 500 && error.status <= 599) {
          this.toastr.error("Not Added");
        }
      });
    setTimeout(() => {
      this.ngOnInit();
    }, 500);
  }
  goToAdd(row) {
this.modalAdd = true; this.submitted = false;





this.nodeEditPropertiesdyanmic_mul.addselectedAttributesdyanmic_mul = ""



this.nodeEditPropertiesauto_mul.addselectedAttributesauto_mul = ""


  }
 submitted = false;
onSubmit() {
  console.log(this.entryForm.value);
 this.submitted = true;
  if (this.entryForm.invalid) {
    return;
  }this.onCreate();

} 


nodeEditPropertiessta_mul  = {   addselectedAttributessta_mul :"",   editselectedAttributessta_mul :"" }
							 selectsta_mul =[
								
 
								'a',
								 

 
								'b',
								 

 
								'c',
								 

							];

selectdynamic ;     
getalldynamic() {
 this.mainService.getAlldynamic().subscribe(data=>{
this.selectdynamic = data;       
console.log(data);
},(error) => {       console.log(error);     });   }							   

selectdyanmic_mul;    
 getalldyanmic_mul () {
		this.mainService.getAlldyanmic_mul().subscribe(data=>{
							      this.selectdyanmic_mul = data;     
  console.log(data);
 },(error) => {       console.log(error);     });   } 
 nodeEditPropertiesdyanmic_mul  = {     addselectedAttributesdyanmic_mul:"",  editselectedAttributesdyanmic_mul :""   }

selectautocom ;    
 getallautocom () {
							    this.mainService.getAllautocom().subscribe(data=>{
							      this.selectautocom = data;       console.log(data);
							    },(error) => {       console.log(error);     });   }

selectauto_mul;    
 getallauto_mul () {
		this.mainService.getAllauto_mul().subscribe(data=>{
							      this.selectauto_mul = data;     
  console.log(data);
 },(error) => {       console.log(error);     });   } 
 nodeEditPropertiesauto_mul  = {     addselectedAttributesauto_mul:"",  editselectedAttributesauto_mul :""   }

// updateaction
}











